if (!(Test-path '.\!_NewNames\')){New-Item '!_NewNames' -ItemType Directory}
Add-Type -AssemblyName PresentationCore
$ext=@('.ttf','.otf')
$elements = 0
[int]$ct=0
[int]$er=0
$log = ''
foreach ($e in ($ext))
	{
		$p='.\*'+$e
		$massiv=Get-ChildItem -Path $p -Recurse -Force
		$elements = $elements + $massiv.Count
		foreach ($a in ($massiv).Fullname)
		{	
			$n = $null
			$f = $null
			$n=(New-Object -TypeName Windows.Media.GlyphTypeface -ArgumentList $a).FamilyNames.Values
			if ($Error.Count -gt $er) 
			{
				echo "$a ОШИБКА ФАЙЛА"
				$log = $log + "$a ОШИБКА ФАЙЛА`n"
				if (!(Test-path '.\!_NewNames\!_Errors')){New-Item '.\!_NewNames\!_Errors' -ItemType Directory}
				Copy-Item $a -Destination ('.\!_NewNames\!_Errors\')
				$er = $Error.Count
				continue
			}
			$f=' '+(New-Object -TypeName Windows.Media.GlyphTypeface -ArgumentList $a).FaceNames.Values[0]
			if ($f -like '*Plain1.0') {	$f=''}
			if ($f.Count -like 1) {	$f=''}
			if ($Error.Count -gt $er) 
			{
				echo "$a ОШИБКА КОПИРОВАНИЯ"
				$log = $log + "$a ОШИБКА КОПИРОВАНИЯ`n"
				Copy-Item $a -Destination ('.\!_NewNames\!_Errors\')
				$er = $Error.Count
				continue
			}
			if (!(Test-path ".\!_NewNames\$n")){New-Item "!_NewNames\$n" -ItemType Directory}
			Copy-Item $a -Destination (".\!_NewNames\$n\$n$f$e")
			$ct = $ct+1
		}
	}
	echo "Скопировано $ct элементов из $elements"
	"Скопировано $ct элементов из $elements`n $log" | Out-File -Encoding Default -FilePath .\!_Log.txt